﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
namespace pac8084WNet
{
    public class pac8084W
    {
        private class ICPDAS
        {
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_GetLibVersion")]
            public static extern Int16 pac_i8084W_GetLibVersion();
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_GetFirmwareVersion")]
            public static extern Int16 pac_i8084W_GetFirmwareVersion(int slot, ref Int16 firmware);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_GetLibDate")]
            public static extern void pac_i8084W_GetLibDate(byte[] libDate);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_InitDriver")]
            public static extern Int16 pac_i8084W_InitDriver(int Slot);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_SetChannelMode")]
            public static extern Int16 pac_i8084W_SetChannelMode(int Slot, int Channel, Int16 Mode);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadCntABPhase")]
            public static extern Int16 pac_i8084W_ReadCntABPhase(int Slot, int Channel, ref Int32 Cnt32U, ref Int32 Overflow);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadCntPulseDir")]
            public static extern Int16 pac_i8084W_ReadCntPulseDir(int Slot, int Channel, ref Int32 Cnt32U, ref Int32 Overflow);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadCntUpDown")]
            public static extern Int16 pac_i8084W_ReadCntUpDown(int Slot, int Channel, ref Int32 Cnt32U, ref Int32 Overflow);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadFreq")]
            public static extern Int16 pac_i8084W_ReadFreq(int Slot, int Channel, ref UInt32 Freq);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadFreq_Float")]
            public static extern Int16 pac_i8084W_ReadFreq_Float(int Slot, int Channel, ref float Freq);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadCntUp")]
            public static extern Int16 pac_i8084W_ReadCntUp(int Slot, int Channel, ref UInt32 Cnt32U, ref Int32 OverFlow);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ClrCnt")]
            public static extern Int16 pac_i8084W_ClrCnt(int Slot, int Channel);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ClrCnt_All")]
            public static extern Int16 pac_i8084W_ClrCnt_All(int Slot);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_RecoverDefaultSetting")]
            public static extern void pac_i8084W_RecoverDefaultSetting(int Slot);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadXorRegister")]
            public static extern Int16 pac_i8084W_ReadXorRegister(int Slot, int Channel, ref Int32 XorReg);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_SetXorRegister")]
            public static extern Int16 pac_i8084W_SetXorRegister(int Slot, int Channel, Int16 XorReg);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadChannelMode")]
            public static extern Int16 pac_i8084W_ReadChannelMode(int Slot, int Channel, ref Int32 Mode);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadLowPassFilter_Us")]
            public static extern Int16 pac_i8084W_ReadLowPassFilter_Us(int Slot, int Channel, ref UInt16 Us);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_SetLowPassFilter_Us")]
            public static extern Int16 pac_i8084W_SetLowPassFilter_Us(int Slot, int Channel, UInt16 Us);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadLowPassFilter_Status")]
            public static extern void pac_i8084W_ReadLowPassFilter_Status(int Slot, int Channel, ref Int32 Status);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_SetLowPassFilter_Status")]
            public static extern void pac_i8084W_SetLowPassFilter_Status(int Slot, int Channel, Int16 Status);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadFreqMode")]
            public static extern void pac_i8084W_ReadFreqMode(int Slot, int Channel, ref Int32 Mode);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_SetFreqMode")]
            public static extern void pac_i8084W_SetFreqMode(int Slot, int Channel, Int16 Mode);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadFreqTimeoutValue")]
            public static extern UInt16 pac_i8084W_ReadFreqTimeoutValue(int Slot, int Channel);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_SetFreqTimeoutValue")]
            public static extern void pac_i8084W_SetFreqTimeoutValue(int Slot, int Channel, UInt16 TimeOutValue);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadDI_Xor")]
            public static extern Int16 pac_i8084W_ReadDI_Xor(int Slot, ref Int32 DI);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_ReadDI_XorLPF")]
            public static extern Int16 pac_i8084W_ReadDI_XorLPF(int Slot, ref Int32 DI);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_SetEdgeDetectMode")]
            public static extern Int16 pac_i8084W_SetEdgeDetectMode(int Slot, int Channel, Int32 EdgeMode);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_GetEdgeDetectMode")]
            public static extern Int16 pac_i8084W_GetEdgeDetectMode(int Slot, int Channel, ref Int32 EdgeMode);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_EepWriteWord")]
            public static extern Int16 pac_i8084W_EepWriteWord(int Slot, Int32 Addr, Int32 Value);
            [DllImport("pac_i8084W_UWP_x64.dll", EntryPoint = "pac_i8084W_EepReadWord")]
            public static extern Int16 pac_i8084W_EepReadWord(int Slot, Int32 Addr, ref Int32 Value);
        }
        public static Int16 LibVersion()
        {
            return ICPDAS.pac_i8084W_GetLibVersion();
        }
        public static Int16 FirmwareVersion(int slot, ref Int16 firmware)
        {
            return ICPDAS.pac_i8084W_GetFirmwareVersion(slot, ref firmware);
        }
        public static string LibDate()
        {
            byte[] libDate = new byte[32];
            ICPDAS.pac_i8084W_GetLibDate(libDate);
            return AscArr2Str(libDate);
        }
        public static Int16 Init(int slot)
        {
            return ICPDAS.pac_i8084W_InitDriver(slot);
        }
        public static Int16 SetLED(int slot, UInt32 led)
        {
            return 0;
        }
        private static string AscArr2Str(byte[] b)
        {
            return System.Text.UnicodeEncoding.Unicode.GetString(
            System.Text.ASCIIEncoding.Convert(System.Text.Encoding.ASCII,
            System.Text.Encoding.Unicode, b), 0, b.Length);
        }
        public static string Arr2Str(byte[] buffer)
        {
            return (new UnicodeEncoding()).GetString(buffer, 0, buffer.Length);
        }
        public static Int16 SetChannelMode(int Slot, int Channel, Int16 Mode)
        {
            return ICPDAS.pac_i8084W_SetChannelMode(Slot, Channel, Mode);
        }
        public static Int16 ReadChannelMode(int Slot, int Channel, ref Int16 Mode)
        {
            Int32 m = 0;
            Int16 ret = ICPDAS.pac_i8084W_ReadChannelMode(Slot, Channel, ref m);
            Mode = (Int16)(m & 0xffff);
            return ret;
        }
        public static void RecoverDefaultSetting(int Slot)
        {
            ICPDAS.pac_i8084W_RecoverDefaultSetting(Slot);
        }
        public static Int16 ReadPulseDir(int Slot, int Channel, ref Int32 Cnt32U, ref Int16 Overflow)
        {
            Int32 o = 0;
            Int16 ret = ICPDAS.pac_i8084W_ReadCntPulseDir(Slot, Channel, ref Cnt32U, ref o);
            Overflow = (Int16)(o & 0xffff);
            return ret;
        }
        public static Int16 ReadUpDown(int Slot, int Channel, ref Int32 Cnt32U, ref Int16 Overflow)
        {
            Int32 o = 0;
            Int16 ret = ICPDAS.pac_i8084W_ReadCntUpDown(Slot, Channel, ref Cnt32U, ref o);
            Overflow = (Int16)(o & 0xffff);
            return ret;
        }
        public static Int16 ReadFreq(int Slot, int Channel, ref UInt32 Freq)
        {
            return ICPDAS.pac_i8084W_ReadFreq(Slot, Channel, ref Freq);
        }
        public static Int16 ReadFreqFloat(int Slot, int Channel, ref float Freq)
        {
            return ICPDAS.pac_i8084W_ReadFreq_Float(Slot, Channel, ref Freq);
        }
        public static Int16 ReadUpCnt(int Slot, int Channel, ref UInt32 Cnt32U, ref UInt16 OverFlow)
        {
            Int32 o = 0;
            Int16 ret = ICPDAS.pac_i8084W_ReadCntUp(Slot, Channel, ref Cnt32U, ref o);
            OverFlow = (UInt16)(o & 0xffff);
            return ret;
        }
        public static Int16 ReadABPhase(int Slot, int Channel, ref Int32 Cnt32U, ref Int16 Overflow)
        {
            Int32 o = 0;
            Int16 ret = ICPDAS.pac_i8084W_ReadCntABPhase(Slot, Channel, ref Cnt32U, ref o);
            Overflow = (Int16)(o & 0xffff);
            return ret;
        }
        public static void ClrCnt(int Slot, int Channel)
        {
            ICPDAS.pac_i8084W_ClrCnt(Slot, Channel);
        }
        public static void ClrAllCnt(int Slot)
        {
            ICPDAS.pac_i8084W_ClrCnt_All(Slot);
        }
        public static Int16 ReadXor(int Slot, int Channel, ref Int16 XorReg)
        {
            Int32 x = 0;
            Int16 ret = ICPDAS.pac_i8084W_ReadXorRegister(Slot, Channel, ref x);
            XorReg = (Int16)(x & 0xffff);
            return ret;
        }
        public static Int16 SetXor(int Slot, int Channel, Int16 XorReg)
        {
            return ICPDAS.pac_i8084W_SetXorRegister(Slot, Channel, XorReg);
        }
        public static Int16 ReadLowPassFilter_Us(int Slot, int Channel, ref UInt16 Us)
        {
            return ICPDAS.pac_i8084W_ReadLowPassFilter_Us(Slot, Channel, ref Us);
        }
        public static Int16 SetLowPassFilter_Us(int Slot, int Channel, UInt16 Us)
        {
            return ICPDAS.pac_i8084W_SetLowPassFilter_Us(Slot, Channel, Us);
        }
        public static void ReadLowPassFilter_Status(int Slot, int Channel, ref Int16 Status)
        {
            Int32 s = 0;
            ICPDAS.pac_i8084W_ReadLowPassFilter_Status(Slot, Channel, ref s);
            Status = (Int16)(s & 0xffff);
        }
        public static void SetLowPassFilter_Status(int Slot, int Channel, Int16 Status)
        {
            ICPDAS.pac_i8084W_SetLowPassFilter_Status(Slot, Channel, Status);
        }
        public static void ReadFreqMode(int Slot, int Channel, ref Int16 Mode)
        {
            Int32 m = 0;
            ICPDAS.pac_i8084W_ReadFreqMode(Slot, Channel, ref m);
            Mode = (Int16)(m & 0xffff);
        }
        public static void SetFreqMode(int Slot, int Channel, Int16 Mode)
        {
            ICPDAS.pac_i8084W_SetFreqMode(Slot, Channel, Mode);
        }
        public static UInt16 ReadFreqTimeoutValue(int Slot, int Channel)
        {
            return ICPDAS.pac_i8084W_ReadFreqTimeoutValue(Slot, Channel);
        }
        public static void SetFreqTimeoutValue(int Slot, int Channel, UInt16 TimeOutValue)
        {
            ICPDAS.pac_i8084W_SetFreqTimeoutValue(Slot, Channel, TimeOutValue);
        }
        public static Int16 ReadDI_Xor(int Slot, ref Int16 DI)
        {
            Int32 i = 0;
            Int16 ret = ICPDAS.pac_i8084W_ReadDI_Xor(Slot, ref i);
            DI = (Int16)(i & 0xffff);
            return ret;
        }
        public static Int16 ReadDI_XorLPF(int Slot, ref Int16 DI)
        {
            Int32 i = 0;
            Int16 ret = ICPDAS.pac_i8084W_ReadDI_XorLPF(Slot, ref i);
            DI = (Int16)(i & 0xffff);
            return ret;
        }
        public static void GetEdgeMode(int Slot, int Channel, ref Int16 Mode)
        {
            Int32 m = 0;
            ICPDAS.pac_i8084W_GetEdgeDetectMode(Slot, Channel, ref m);
            Mode = (Int16)(m & 0xffff);
        }
        public static void SetEdgeMode(int Slot, int Channel, Int16 Mode)
        {
            ICPDAS.pac_i8084W_SetEdgeDetectMode(Slot, Channel, Mode);
        }
        public static Int16 WriteEEP(int slot, Int32 addr, Int16 data)
        {
            return ICPDAS.pac_i8084W_EepWriteWord(slot, addr, data);
        }
        public static Int16 ReadEEP(int slot, Int32 addr, ref Int16 data)
        {
            Int32 d = 0;
            Int16 ret = ICPDAS.pac_i8084W_EepReadWord(slot, addr, ref d);
            data = (Int16)d;
            return ret;
        }
    }
}