﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.UI.Popups;
// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x404

namespace i8084W_Basic_Info_Csharp
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class MainPage : Page
    {
        int slot = -1;
        ComboBox[] mode_cbx;
        Button[] set_btn;
        TextBox[] value_txt;
        TextBox[] over_txt;
        Button[] read_btn;
        Button[] clear_btn;
        Windows.UI.Popups.MessageDialog messageDialog;
        public MainPage()
        {
            Int16 i = 0;
            this.InitializeComponent();
            messageDialog = new MessageDialog("Module initialization failed, please select correct slot.");

            mode_cbx = new ComboBox[8] { M0_cbx, M1_cbx, M2_cbx, M3_cbx, M4_cbx, M5_cbx, M6_cbx, M7_cbx };
            set_btn = new Button[8] { S0_btn, S1_btn, S2_btn, S3_btn, S4_btn, S5_btn, S6_btn, S7_btn };
            value_txt = new TextBox[8] { V0_txt, V1_txt, V2_txt, V3_txt, V4_txt, V5_txt, V6_txt, V7_txt };
            over_txt = new TextBox[8] { O0_txt, O1_txt, O2_txt, O3_txt, O4_txt, O5_txt, O6_txt, O7_txt };
            read_btn = new Button[8] { R0_btn, R1_btn, R2_btn, R3_btn, R4_btn, R5_btn, R6_btn, R7_btn };
            clear_btn = new Button[8] { C0_btn, C1_btn, C2_btn, C3_btn, C4_btn, C5_btn, C6_btn, C7_btn };
            for (i = 0; i < 8; ++i)
            {
                mode_cbx[i].SelectedIndex = 0;
                value_txt[i].Text = "--";
                over_txt[i].Text = "--";
            }

            Library_ver_txt.Text = String.Format("{0:X4}", pac8084WNet.pac8084W.LibVersion());
            Library_date_txt.Text = pac8084WNet.pac8084W.LibDate();
        }

        private void slot_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Int16 fw = 0;
            slot = slot_cbx.SelectedIndex;
            if (pac8084WNet.pac8084W.Init(slot) == 0)
            {
                pac8084WNet.pac8084W.FirmwareVersion(slot, ref fw);
                Firmware_ver_txt.Text = String.Format("{0:X4}", fw);
                Status_txt.Text = "Init OK!!";
            }
            else
            {
                Status_txt.Text = "Init Failed!!";
                slot = -1;
            }
        }

        private void Mode_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Int16 i = 0;
            Int16 ch = 0;
            ComboBox cbx = sender as ComboBox;
            for (i = 0; i < 8; ++i)
            {
                if (mode_cbx[i].Name == cbx.Name)
                {
                    ch = i;
                    break;
                }
            }
            switch ((Int16)cbx.SelectedIndex)
            {
                case 0:
                case 1:
                case 4:
                    {
                        if (ch % 2 == 0)
                        {
                            mode_cbx[ch + 1].IsEnabled = false;
                            mode_cbx[ch + 1].SelectedIndex = cbx.SelectedIndex;
                            set_btn[ch + 1].IsEnabled = false;
                            value_txt[ch + 1].IsEnabled = false;
                            value_txt[ch].Text = "--";
                            over_txt[ch + 1].IsEnabled = false;
                            over_txt[ch].Text = "--";
                            read_btn[ch + 1].IsEnabled = false;
                            clear_btn[ch + 1].IsEnabled = false;
                        }
                        else
                        {
                            mode_cbx[ch].IsEnabled = false;
                            mode_cbx[ch - 1].SelectedIndex = cbx.SelectedIndex;
                            set_btn[ch].IsEnabled = false;
                            value_txt[ch].IsEnabled = false;
                            value_txt[ch].Text = "--";
                            over_txt[ch].IsEnabled = false;
                            over_txt[ch].Text = "--";
                            read_btn[ch].IsEnabled = false;
                            clear_btn[ch].IsEnabled = false;
                        }
                        break;
                    }
                case 2:
                case 3:
                    {
                        if (ch % 2 == 0)
                        {
                            mode_cbx[ch + 1].IsEnabled = true;
                            mode_cbx[ch + 1].SelectedIndex = cbx.SelectedIndex;
                            set_btn[ch + 1].IsEnabled = true;
                            value_txt[ch + 1].IsEnabled = true;
                            over_txt[ch + 1].IsEnabled = true;
                            read_btn[ch + 1].IsEnabled = true;
                            clear_btn[ch + 1].IsEnabled = true;
                        }
                        break;
                    }
            }
        }

        private async void Set_btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 i = 0;
            Int16 ch = 0;
            Button btn = sender as Button;
            if (slot == -1)
            {
                await messageDialog.ShowAsync();
            }
            for (i = 0; i < 8; ++i)
            {
                if (set_btn[i].Name == btn.Name)
                {
                    ch = i;
                    break;
                }
            }
            pac8084WNet.pac8084W.SetChannelMode(slot, ch, (Int16)mode_cbx[ch].SelectedIndex);
            pac8084WNet.pac8084W.ClrCnt(slot, ch);
        }

        private async void Read_btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 i = 0;
            Int16 ch = 0;
            UInt32 u32 = 0;
            UInt16 u16 = 0;
            Int32 s32 = 0;
            Int16 s16 = 0;
            Button btn = sender as Button;
            if (slot == -1)
            {
                await messageDialog.ShowAsync();
            }
            for (i = 0; i < 8; ++i)
            {
                if (read_btn[i].Name == btn.Name)
                {
                    ch = i;
                    break;
                }
            }
            switch ((Int16)mode_cbx[ch].SelectedIndex)
            {
                case 0:
                    {
                        pac8084WNet.pac8084W.ReadPulseDir(slot, ch, ref s32, ref s16);
                        value_txt[ch].Text = s32.ToString();
                        over_txt[ch].Text = s16.ToString();
                        break;
                    }
                case 1:
                    {
                        pac8084WNet.pac8084W.ReadUpDown(slot, ch, ref s32, ref s16);
                        value_txt[ch].Text = s32.ToString();
                        over_txt[ch].Text = s16.ToString();
                        break;
                    }
                case 2:
                    {
                        pac8084WNet.pac8084W.ReadFreq(slot, ch, ref u32);
                        value_txt[ch].Text = u32.ToString();
                        over_txt[ch].Text = "-none-";
                        break;
                    }
                case 3:
                    {
                        pac8084WNet.pac8084W.ReadUpCnt(slot, ch, ref u32, ref u16);
                        value_txt[ch].Text = u32.ToString();
                        over_txt[ch].Text = u16.ToString();
                        break;
                    }

                case 4:
                    {
                        pac8084WNet.pac8084W.ReadABPhase(slot, ch, ref s32, ref s16);
                        value_txt[ch].Text = s32.ToString();
                        over_txt[ch].Text = s16.ToString();
                        break;
                    }
            }
        }

        private async void Clear_btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 i = 0;
            Int16 ch = 0;
            UInt32 u32 = 0;
            UInt16 u16 = 0;
            Int32 s32 = 0;
            Int16 s16 = 0;
            Button btn = sender as Button;
            if (slot == -1)
            {
                await messageDialog.ShowAsync();
            }
            for (i = 0; i < 8; ++i)
            {
                if (clear_btn[i].Name == btn.Name)
                {
                    ch = i;
                    break;
                }
            }
            pac8084WNet.pac8084W.ClrCnt(slot, ch);
            switch ((Int16)mode_cbx[ch].SelectedIndex)
            {
                case 0:
                    {
                        pac8084WNet.pac8084W.ReadPulseDir(slot, ch, ref s32, ref s16);
                        value_txt[ch].Text = s32.ToString();
                        over_txt[ch].Text = s16.ToString();
                        break;
                    }
                case 1:
                    {
                        pac8084WNet.pac8084W.ReadUpDown(slot, ch, ref s32, ref s16);
                        value_txt[ch].Text = s32.ToString();
                        over_txt[ch].Text = s16.ToString();
                        break;
                    }
                case 2:
                    {
                        pac8084WNet.pac8084W.ReadFreq(slot, ch, ref u32);
                        value_txt[ch].Text = u32.ToString();
                        over_txt[ch].Text = "-none-";
                        break;
                    }
                case 3:
                    {
                        pac8084WNet.pac8084W.ReadUpCnt(slot, ch, ref u32, ref u16);
                        value_txt[ch].Text = u32.ToString();
                        over_txt[ch].Text = u16.ToString();
                        break;
                    }

                case 4:
                    {
                        pac8084WNet.pac8084W.ReadABPhase(slot, ch, ref s32, ref s16);
                        value_txt[ch].Text = s32.ToString();
                        over_txt[ch].Text = s16.ToString();
                        break;
                    }
            }
        }

        private void Exit_btn_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Exit();
        }
    }
}